//
// TextRange.jsx
//
// =======================================================
//@includepath "/c/Program Files/Adobe/Adobe Photoshop CS2/xtools"
//
//-@include "xlib/PSConstants.js"
//-@include "xlib/stdlib.js"
//-@include "xlib/Getter.jsx"
//
//-@include "xlib/Action.js"
//-@include "xlib/xml/atn2xml.jsx"
//

//
// PSConstants
//
cTID = function(s) { return app.charIDToTypeID(s); };
sTID = function(s) { return app.stringIDToTypeID(s); };

PSClass = function() {};
PSEnum = function() {};
PSEvent = function() {};
PSForm = function() {};
PSKey = function() {};
PSType = function() {};
PSUnit = function() {};
PSString = function() {};

PSClass.AntiAliasedPICTAcquire = cTID('AntA');
PSClass.Color = cTID('Clr ');
PSClass.Document = cTID('Dcmn');
PSClass.Point = cTID('Pnt ');
PSClass.Property = cTID('Prpr');
PSClass.Layer = cTID('Lyr ');
PSClass.RGBColor = cTID('RGBC');
PSClass.TextLayer = cTID('TxLr');
PSClass.TextStyle = cTID('TxtS');
PSClass.TextStyleRange = cTID('Txtt');

PSEnum.AntiAliasCrisp = cTID('AnCr');
PSEnum.Horizontal = cTID('Hrzn');
PSEnum.JustifyAll = cTID('JstA');
PSEnum.Left = cTID('Left');
PSEnum.None = cTID('None');
PSEnum.Normal = cTID('Nrml');
PSEnum.Target = cTID('Trgt');
PSEnum.Vertical = cTID('Vrtc');

PSEvent.Set = cTID('setd');

PSKey.AutoKern = cTID('AtKr');
PSKey.BaselineShift = cTID('Bsln');
PSKey.Blue = cTID('Bl  ');
PSKey.Color =cTID('Clr ');
PSKey.Fill = cTID('Fl  ');
PSKey.FontName = cTID('FntN');
PSKey.FontScript = cTID('Scrp');
PSKey.FontStyleName = cTID('FntS');
PSKey.FontTechnology = cTID('FntT');
PSKey.From = cTID('From');
PSKey.Green = cTID('Grn ');
PSKey.HorizontalScale = cTID('HrzS');
PSKey.Orientation = cTID('Ornt');
PSKey.Red = cTID('Rd  ');
PSKey.SizeKey = cTID('Sz  ');
PSKey.Spacing = cTID('Spcn');
PSKey.Stroke = cTID('Strk');
PSKey.Text = cTID('Txt ');
PSKey.TextStyle = cTID('TxtS');
PSKey.TextStyleRange = cTID('Txtt');
PSKey.To = cTID('T   ');
PSKey.Tracking = cTID('Trck');
PSKey.Underline = cTID('Undl');
PSKey.VerticalScale = cTID('VrtS');

PSString.alignByAscent = sTID('alignByAscent');
PSString.alternateLigatures = sTID('alternateLigatures');
PSString.altligature = sTID('altligature');
PSString.autoLeading = sTID('autoLeading');
PSString.autoLeadingPercentage = sTID('autoLeadingPercentage');
PSString.autoTCY = sTID('autoTCY');
PSString.base = sTID('base');
PSString.baseline = sTID('baseline');
PSString.baselineDirection = sTID('baselineDirection');
PSString.burasagari = sTID('burasagari');
PSString.burasagariNone = sTID('burasagariNone');
PSString.buttCap = sTID('buttCap');
PSString.characterRotation = sTID('characterRotation');
PSString.columnCount = sTID('columnCount');
PSString.columnGutter = sTID('columnGutter');
PSString.connectionForms = sTID('connectionForms');
PSString.contextualLigatures = sTID('contextualLigatures');
PSString.defaultForm = sTID('defaultForm');
PSString.defaultStyle = sTID('defaultStyle');
PSString.defaultTabWidth = sTID('defaultTabWidth');
PSString.dropCapMultiplier = sTID('dropCapMultiplier');
PSString.enableWariChu = sTID('enableWariChu');
PSString.endIndent = sTID('endIndent');
PSString.englishLanguage = sTID('englishLanguage');
PSString.figureStyle = sTID('figureStyle');
PSString.fillFirst = sTID('fillFirst');
PSString.fillOverPrint = sTID('fillOverPrint');
PSString.firstBaselineMinimum = sTID('firstBaselineMinimum');
PSString.firstLineIndent = sTID('firstLineIndent');
PSString.fontCaps = sTID('fontCaps');
PSString.fontPostScriptName = sTID('fontPostScriptName');
PSString.fractions = sTID('fractions');
PSString.frameBaselineAlignment = sTID('frameBaselineAlignment');
PSString.gridAlignment = sTID('gridAlignment');
PSString.hangingRoman = sTID('hangingRoman');
PSString.hyphenate = sTID('hyphenate');
PSString.hyphenateCapitalized = sTID('hyphenateCapitalized');
PSString.hyphenateLimit = sTID('hyphenateLimit');
PSString.hyphenatePostLength = sTID('hyphenatePostLength');
PSString.hyphenatePreLength = sTID('hyphenatePreLength');
PSString.hyphenateWordSize = sTID('hyphenateWordSize');
PSString.hyphenationPreference = sTID('hyphenationPreference');
PSString.hyphenationZone = sTID('hyphenationZone');
PSString.italics = sTID('italics');
PSString.japaneseAlternate = sTID('japaneseAlternate');
PSString.jiDori = sTID('jiDori');
PSString.justificationGlyphDesired = sTID('justificationGlyphDesired');
PSString.justificationGlyphMaximum = sTID('justificationGlyphMaximum');
PSString.justificationGlyphMinimum = sTID('justificationGlyphMinimum');
PSString.justificationLetterDesired = sTID('justificationLetterDesired');
PSString.justificationLetterMaximum = sTID('justificationLetterMaximum');
PSString.justificationLetterMinimum = sTID('justificationLetterMinimum');
PSString.justificationWordDesired = sTID('justificationWordDesired');
PSString.justificationWordMaximum = sTID('justificationWordMaximum');
PSString.justificationWordMinimum = sTID('justificationWordMinimum');
PSString.kana = sTID('kana');
PSString.keepTogether = sTID('keepTogether');
PSString.kerningRange = sTID('kerningRange');
PSString.kurikaeshiMojiShori = sTID('kurikaeshiMojiShori');
PSString.leadingBelow = sTID('leadingBelow');
PSString.leadingType = sTID('leadingType');
PSString.leftAki = sTID('leftAki');
PSString.ligature = sTID('ligature');
PSString.lineCap = sTID('lineCap');
PSString.lineDashOffset = sTID('lineDashoffset');
PSString.lineJoin = sTID('lineJoin');
PSString.lineWidth = sTID('lineWidth');
PSString.metricsKern = sTID('metricsKern');
PSString.miterJoin = sTID('miterJoin');
PSString.miterLimit = sTID('miterLimit');
PSString.mojiKumiName = sTID('mojiKumiName');
PSString.mojiZume = sTID('mojiZume');
PSString.noBreak = sTID('noBreak');
PSString.oldStyle = sTID('oldStyle');
PSString.ordinals = sTID('ordinals');
PSString.ornaments = sTID('ornaments');
PSString.otbaseline = sTID('otbaseline');
PSString.paragraphStyle = sTID('paragraphStyle');
PSString.paragraphStyleRange = sTID('paragraphStyleRange');
PSString.preferredKinsokuOrder = sTID('preferredKinsokuOrder');
PSString.proportionalMetrics = sTID('proportionalMetrics');
PSString.pushIn = sTID('pushIn');
PSString.rightAki = sTID('rightAki');
PSString.roman = sTID('roman');
PSString.rotated = sTID('rotated');
PSString.rowCount = sTID('rowCount');
PSString.rowGutter = sTID('rowGutter');
PSString.rowMajorOrder = sTID('rowMajorOrder');
PSString.ruby = sTID('ruby');
PSString.singleWordJustification = sTID('singleWordJustification');
PSString.spaceAfter = sTID('spaceAfter');
PSString.spaceBefore = sTID('spaceBefore');
PSString.startIndent = sTID('startIndent');
PSString.strikethrough = sTID('strikethrough');
PSString.strikethroughOff = sTID('strikethroughOff');
PSString.strokeColor = sTID('strokeColor');
PSString.strokeOverPrint = sTID('strokeOverPrint');
PSString.stylisticAlternates = sTID('stylisticAlternates');
PSString.swash = sTID('swash');
PSString.syntheticBold = sTID('syntheticBold');
PSString.syntheticItalic = sTID('syntheticItalic');
PSString.tcyLeftRight = sTID('tcyLeftRight');
PSString.tcyUpDown = sTID('tcyUpDown');
PSString.textEveryLineComposer = sTID('textEveryLineComposer');
PSString.textGridding = sTID('textGridding');
PSString.textLanguage = sTID('textLanguage');
PSString.textShape = sTID('textShape');
PSString.textType = sTID('TEXT');
PSString.titling = sTID('titling');
PSString.tx = sTID('tx');
PSString.ty = sTID('ty');
PSString.underlineOff = sTID('underlineOff');
PSString.underlineOffset = sTID('underlineOffset');
PSString.wariChuAutoJustify = sTID('wariChuAutoJustify');
PSString.wariChuCount = sTID('wariChuCount');
PSString.wariChuJustification = sTID('wariChuJustification');
PSString.wariChuLineGap = sTID('wariChuLineGap');
PSString.wariChuOrphan = sTID('wariChuOrphan');
PSString.wariChuScale = sTID('wariChuScale');
PSString.wariChuWidow = sTID('wariChuWidow');
PSString.warp = sTID('warp');
PSString.warpNone = sTID('warpNone');
PSString.warpPerspective = sTID('warpPerspective');
PSString.warpPerspectiveOther = sTID('warpPerspectiveOther');
PSString.warpRotate = sTID('warpRotate');
PSString.warpStyle = sTID('warpStyle');
PSString.warpValue = sTID('warpValue');
PSString.xx = sTID('xx');
PSString.xy = sTID('xy');
PSString.yx = sTID('yx');
PSString.yy = sTID('yy');

PSType.Alignment = cTID('Alg ');
PSType.AntiAlias = cTID('Annt');
PSType.Ordinal = cTID('Ordn');

PSUnit.Points = cTID('#Pnt');

//
// Code extracted from Getter.jsx
//

Getter = function() {};

Getter.getDocumentIndex = function(doc) {
  var docs = app.documents;
  for (var i = 0; i < docs.length; i++) {
    if (doc == docs[i]) {
      return i+1;
    }
  }
  return undefined;
};

Getter.getDescriptorElement = function(desc, key) {
  if (!desc.hasKey(key)) {
    return undefined
  }
  var typeID = desc.getType(key);
  var v;
  switch (typeID) {
    case DescValueType.ALIASTYPE:   v = desc.getPath(key); break;
    case DescValueType.BOOLEANTYPE: v = desc.getBoolean(key); break;
    case DescValueType.CLASSTYPE:   v = desc.getClass(key); break;
    case DescValueType.DOUBLETYPE:  v = desc.getDouble(key); break;
    case DescValueType.ENUMERATEDTYPE:
      v = new Object();
      v.type = desc.getEnumerationType(key);
      v.value = desc.getEnumerationValue(key);
      break;
    case DescValueType.INTEGERTYPE: v = desc.getInteger(key); break;
    case DescValueType.LISTTYPE:    v = desc.getList(key); break;
    case DescValueType.OBJECTTYPE:
      v = new Object();
      v.type = desc.getObjectType(key);
      v.value = desc.getObjectValue(key);
      break;
    case DescValueType.RAWTYPE:       v = desc.getData(key); break;
    case DescValueType.REFERENCETYPE: v = desc.getReference(key); break;
    case DescValueType.STRINGTYPE:    v = desc.getString(key); break;
    case DescValueType.UNITDOUBLETYPE:
      v = new Object();
      v.type = desc.getUnitDoubleType(key);
      v.value = desc.getUnitDoubleValue(key);
      break;
  }

  return v;
};

Getter.getInfoByIndexIndex = function(childIndex, parentIndex, childID,
                                      parentID, key) {
  var ref = new ActionReference();
  if (isNaN(childID)) {
    childID = cTID(childID);
  }
  if (isNaN(parentID)) {
    parentID = cTID(parentID);
  }
  if (key != undefined) {
    if (isNaN(key)) {
      key = cTID(key);
    }
    ref.putProperty(PSClass.Property, key);
  }
  ref.putIndex(childID, childIndex);
  ref.putIndex(parentID, parentIndex);

  var desc = app.executeActionGet(ref);

  return (key ? Getter.getDescriptorElement(desc, key) : desc);
};

Getter.getLayerDescriptor = function(doc, layer) {
  var docIndex = Getter.getDocumentIndex(doc);
  var layerIndex = -1;
  var layers = doc.layers;

  var hasBackground = false;
  try {
    doc.backgroundLayer;
    hasBackground = true;
  } catch (e) {
  }

  for (var i = 0; i < layers.length; i++) {
    if (layer == layers[i]) {
      layerIndex = layers.length - i;
      if (hasBackground) layerIndex--;
      break;
    }
  }
  if (layerIndex == -1) {
    throw "Unable to find indicated layer in the document.";
  }

  return Getter.getInfoByIndexIndex(layerIndex, docIndex, PSClass.Layer,
                                    PSClass.Document);
};

//
//============================ TextRange code ================================
//
TextStyleRange = function(from, to, textStyle) {
  if (this.constructor != arguments.callee) {
    return new TextStyleRange(from, to, textStyle);
  } 
  var self = this;
  
  self.from = from;
  self.to = to;
  self.textStyle = textStyle;
};
TextStyleRange.prototype.typename = "TextStyleRange";

TextStyleRange.prototype.toString = function() {
  return "{from: " + this.from + ", to: " + this.to +
         ", style: " + this.textStyle + "}"; 
};

TextStyleRange.prototype.asActionDescriptor = function() {
  var self = this;
  var desc = new ActionDescriptor();

  desc.putInteger(PSKey.From, self.from);
  desc.putInteger(PSKey.To, self.to);
  desc.putObject(PSKey.TextStyle, PSClass.TextStyle,
                 self.textStyle.asActionDescriptor());

  return desc;
};

TextStyleRange.prototype.dupe = function() {
  return new TextStyleRange(this.to, this.from, this.textStyle);
};


TextStyleRanges = function() {
  var self = this;

  self.length = 0;
  self.tsrs = [];
};
TextStyleRanges.prototype.typename = "TextStyleRanges";
TextStyleRanges.prototype.add = function(tsr) {
  var self = this;
  self.length++;
  self.tsrs.push(tsr);
  return tsr;
};
TextStyleRanges.prototype.remove = function(index) {
  var self = this;
  self.tsrs.splice(index, 1);
  self.length--;
};
TextStyleRanges.prototype.get = function(index) {
  return self.tsrs[index];
};

//
// all arguments are options.
//   doc      defaults to app.activeDocument
//   layer    defaults to doc.activeLayer
//   contents defaults to layer.textItem.contents
//   replace  defaults to true
//
TextStyleRanges.prototype.apply = function(doc, layer, contents, replace) {
  var self = this;
  var ranges = self.tsrs;

  if (ranges == null) {
    return;
  }
  if (doc == undefined) {
    doc = app.activeDocument;
  } else {
    if (doc != app.activeDocument) {
      app.activeDocument = doc;
    }
  }
  if (layer == undefined) {
    if (layer != doc.activeLayer) {
      layer = doc.activeLayer;
    }
  }
  if (layer.kind != LayerKind.TEXT) {
    throw "The layer \"" + layer.name + "\" is not a text layer.";
  }
  replace = (replace != false);  // default is true...

  var desc = Getter.getLayerDescriptor(doc, layer);
  var textDesc = desc.getObjectValue(PSKey.Text);
  if (!contents) {
    contents = textDesc.getString(PSKey.Text);
  } else {
    textDesc.putString(PSKey.Text, contents);
  }

  var tsrList = textDesc.getList(PSKey.TextStyleRange);
  var tsr = tsrList.getObjectValue(0);
  var ts = tsr.getObjectValue(PSKey.TextStyle);
  TextStyle.setDefaults(ts);

  if (replace) {
    tsrList = self.asActionList(contents.length);
    textDesc.putList(PSKey.TextStyleRange, tsrList);
  } else {
    throw "There is currently no support for modifying an existing range set.";
  }

  if (textDesc.hasKey(PSString.paragraphStyleRange)) {
    var psrList = textDesc.getList(PSString.paragraphStyleRange);
    var psrIndex = psrList.count - 1;
    var psr = psrList.getObjectValue(psrIndex)
    psr.putInteger(PSKey.From, contents.length);
  }

  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated(PSClass.TextLayer, PSType.Ordinal, PSEnum.Target);
  desc.putReference(cTID('null'), ref);
  desc.putObject(PSKey.To, PSClass.TextLayer, textDesc);
  
  executeAction(PSEvent.Set, desc, DialogModes.NO);
};
TextStyleRanges.prototype.asActionList = function(len) {
  var self = this;

  if (!len) {
    return;
  }

  var ranges = self.tsrs;
  var rmap = [];
  rmap.length = len;

  for (var i = 0; i < ranges.length; i++) {
    var range = ranges[i];
    if (range.to == undefined || range.to > len) {
      range.to = len;
    }
    if (range.from > range.to) {
      throw "Bad text range values";
    }
    for (var j = range.from; j < range.to; j++) {
      rmap[j] = i;
    }
  }

  //  $.level = 1; debugger;

  var exranges = [];
  var start = 0;
  var rindex = rmap[0];

  for (var i = 1; i < rmap.length; i++) {
    if (rmap[i] != rindex) {
      exranges.push(new TextStyleRange(start, i, ranges[rindex].textStyle));
      start = i;
      rindex = rmap[start];
    }
  }

  exranges.push(new TextStyleRange(start, i, ranges[rindex].textStyle));

  var str = '';
  for (var i = 0; i < exranges.length; i++) {
    str += exranges[i] + '\n';
  }

  // $.level = 1; debugger;

  var list = new ActionList();
  for (var i = 0; i < exranges.length; i++) {
    list.putObject(PSClass.TextStyleRange, exranges[i].asActionDescriptor());
  }
  return list;
};

TextStyle = function(font, size, color) {
  if (this.constructor != arguments.callee) {
    return new TextStyle(font, size, color);
  } 
  var self = this;

  if (font && font.constructor == String) {
    font = app.fonts.getByName(font);
  }
  self.font  = font;
  self.size  = size;
  self.color = color;
};
TextStyle.prototype.typename = "TextStyle";

TextStyle.setDefaults = function(desc) {
  var fontName = desc.getString(PSString.fontPostScriptName);
  TextStyle.defaultFont = app.fonts.getByName(fontName);
  TextStyle.defaultSize = desc.getUnitDoubleValue(PSKey.SizeKey,
                                                  PSUnit.Points);
  var colorDesc = desc.getObjectValue(PSClass.Color);
  var color = new SolidColor()
  color.rgb.red   = colorDesc.getDouble(PSKey.Red);
  color.rgb.green = colorDesc.getDouble(PSKey.Green);
  color.rgb.blue  = colorDesc.getDouble(PSKey.Blue);
  TextStyle.defaultColor = color;
};

TextStyle.toRGBColor = function(r, g, b) {
  var c = new RGBColor();
  if (r instanceof Array) {
    b = r[2]; g = r[1]; r = r[0];
  }
  c.red = Math.round(r); c.green = Math.round(g); c.blue = Math.round(b);
  var sc = new SolidColor();
  sc.rgb = c;
  return sc;
};

TextStyle.prototype.toString = function() {
  var self = this;
  var str = '{';
  var font  = (self.font  != undefined) ? self.font : TextStyle.defaultFont;
  var size  = (self.size  != undefined) ? self.size : TextStyle.defaultSize;
  var color = (self.color != undefined) ? self.color : TextStyle.defaultColor;
  str += "font: " + font + ", ";
  str += "size: " + size + ", ";
  str += "color: " + RGBtoString(color) + "}";
  return str;
};

TextStyle.defaultFont = app.fonts.getByName("ArialMT");
TextStyle.defaultSize = 20.0;
TextStyle.defaultColor = TextStyle.toRGBColor(0, 255, 255);

TextStyle.prototype.asActionDescriptor = function() {
  var self  = this;
  var font  = self.font ? self.font : TextStyle.defaultFont;
  var size  = self.size ? self.size : TextStyle.defaultSize;
  var color = self.color ? self.color : TextStyle.defaultColor;
  var tsDesc = new ActionDescriptor();
  if (!font) {
    font = TextStyle.defaultFont;
  }
  tsDesc.putString(PSString.fontPostScriptName,  font.postScriptName);
  tsDesc.putString(PSKey.FontName, font.family);
  tsDesc.putString(PSKey.FontStyleName, font.style);
  tsDesc.putInteger(PSKey.FontScript, 0);
  tsDesc.putInteger(PSKey.FontTechnology, 1);
  if (!size) {
    size = TextStyle.defaultSize;
  }
  tsDesc.putUnitDouble(PSKey.SizeKey, PSUnit.Points, size);
  tsDesc.putDouble(PSKey.HorizontalScale, 100.000000);
  tsDesc.putDouble(PSKey.VerticalScale, 100.000000);
  tsDesc.putBoolean(PSString.syntheticBold, false);
  tsDesc.putBoolean(PSString.syntheticItalic, false);
  tsDesc.putBoolean(PSString.autoLeading, true);
  tsDesc.putInteger(PSKey.Tracking, 0);
  tsDesc.putUnitDouble(PSKey.BaselineShift, PSUnit.Points, 0.000000);
  tsDesc.putDouble(PSString.characterRotation, 0.000000);
  tsDesc.putEnumerated(PSKey.AutoKern,
                       PSKey.AutoKern,
                       PSString.metricsKern);
  tsDesc.putEnumerated(PSString.fontCaps,
                       PSString.fontCaps,
                       PSEnum.Normal);
  tsDesc.putEnumerated(PSString.baseline,
                       PSString.baseline,
                       PSEnum.Normal);
  tsDesc.putEnumerated(PSString.otbaseline,
                       PSString.otbaseline,
                       PSEnum.Normal);
  tsDesc.putEnumerated(PSString.strikethrough,
                       PSString.strikethrough,
                       PSString.strikethroughOff);
  tsDesc.putEnumerated(PSKey.Underline,
                       PSKey.Underline,
                       PSString.underlineOff);
  tsDesc.putUnitDouble(PSString.underlineOffset, PSUnit.Points, 0.000000);
  tsDesc.putBoolean(PSString.ligature, true);
  tsDesc.putBoolean(PSString.altligature, false);
  tsDesc.putBoolean(PSString.contextualLigatures, false);
  tsDesc.putBoolean(PSString.alternateLigatures, false);
  tsDesc.putBoolean(PSString.oldStyle, false);
  tsDesc.putBoolean(PSString.fractions, false);
  tsDesc.putBoolean(PSString.ordinals, false);
  tsDesc.putBoolean(PSString.swash, false);
  tsDesc.putBoolean(PSString.titling, false);
  tsDesc.putBoolean(PSString.connectionForms, false);
  tsDesc.putBoolean(PSString.stylisticAlternates, false);
  tsDesc.putBoolean(PSString.ornaments, false);
  tsDesc.putEnumerated(PSString.figureStyle,
                       PSString.figureStyle,
                       PSEnum.Normal);
  tsDesc.putBoolean(PSString.proportionalMetrics, false);
  tsDesc.putBoolean(PSString.kana, false);
  tsDesc.putBoolean(PSString.italics, false);
  tsDesc.putBoolean(PSString.ruby, false);
  tsDesc.putEnumerated(PSString.baselineDirection,
                       PSString.baselineDirection,
                       PSString.rotated);
  tsDesc.putEnumerated(PSString.textLanguage,
                       PSString.textLanguage,
                       PSString.englishLanguage);
  tsDesc.putEnumerated(PSString.japaneseAlternate,
                       PSString.japaneseAlternate,
                       PSString.defaultForm);
  tsDesc.putDouble(PSString.mojiZume, 0.000000);
  tsDesc.putEnumerated(PSString.gridAlignment,
                       PSString.gridAlignment,
                       PSString.roman);
  tsDesc.putBoolean(PSString.enableWariChu, false);
  tsDesc.putInteger(PSString.wariChuCount, 2);
  tsDesc.putInteger(PSString.wariChuLineGap, 0);
  tsDesc.putDouble(PSString.wariChuScale, 0.500000);
  tsDesc.putInteger(PSString.wariChuWidow, 2);
  tsDesc.putInteger(PSString.wariChuOrphan, 2);
  tsDesc.putEnumerated(PSString.wariChuJustification,
                       PSString.wariChuJustification,
                       PSString.wariChuAutoJustify);
  tsDesc.putInteger(PSString.tcyUpDown, 0);
  tsDesc.putInteger(PSString.tcyLeftRight, 0);
  tsDesc.putDouble(PSString.leftAki, -1.000000);
  tsDesc.putDouble(PSString.rightAki, -1.000000);
  tsDesc.putInteger(PSString.jiDori, 0);
  tsDesc.putBoolean(PSString.noBreak, false);

  var colorDesc = new ActionDescriptor();
  if (color instanceof SolidColor) {
    color = color.rgb;
  }
  colorDesc.putDouble(PSKey.Red, color.red);
  colorDesc.putDouble(PSKey.Green, color.green);
  colorDesc.putDouble(PSKey.Blue, color.blue);
  tsDesc.putObject(PSKey.Color, PSClass.RGBColor, colorDesc);

  var strokeDesc = new ActionDescriptor();
  strokeDesc.putDouble(PSKey.Red, 0.000000);
  strokeDesc.putDouble(PSKey.Green, 0.000000);
  strokeDesc.putDouble(PSKey.Blue, 0.000000);
  tsDesc.putObject(PSString.strokeColor, PSClass.RGBColor, strokeDesc);

  tsDesc.putBoolean(PSKey.Fill, true);
  tsDesc.putBoolean(PSKey.Stroke, false);
  tsDesc.putBoolean(PSString.fillFirst, true);
  tsDesc.putBoolean(PSString.fillOverPrint, false);
  tsDesc.putBoolean(PSString.strokeOverPrint, false);
  tsDesc.putEnumerated(PSString.lineCap,
                       PSString.lineCap,
                       PSString.buttCap);
  tsDesc.putEnumerated(PSString.lineJoin,
                       PSString.lineJoin,
                       PSString.miterJoin);
  tsDesc.putUnitDouble(PSString.lineWidth, PSUnit.Points, 0.009999);
  tsDesc.putUnitDouble(PSString.miterLimit, PSUnit.Points, 0.009999);
  tsDesc.putDouble(PSString.lineDashOffset, 0.000000);

  return tsDesc;
};

function tsrDemo(doc) {
  var s1 = new TextStyle("ArialMT");
  var s2 = new TextStyle("Courier-Bold", 30, TextStyle.toRGBColor(0, 255, 0));
  var s3 = new TextStyle(undefined, 42, TextStyle.toRGBColor(255, 0, 0));

  var str = "123567875688\radsfasfasdfasdfasdf\n(&#^&^#$";

  var ranges = new TextStyleRanges();
  ranges.add(new TextStyleRange(0, str.length, s1));
  ranges.add(new TextStyleRange(5, 10, s2));
  ranges.add(new TextStyleRange(7, 15, s3));
  ranges.add(new TextStyleRange(25, undefined, s2));

  // $.level = 1; debugger;

  if (!doc) {
    doc = app.documents.add(640, 480, 72, "MultiFont Test");
    var layer = doc.artLayers.add();
    layer.name = "Test";
    layer.kind = LayerKind.TEXT;
    var titem = layer.textItem;
    titem.size = 20;
    titem.kind = TextType.PARAGRAPHTEXT;
    titem.contents = "test";
    titem.position = [50, 50];
    titem.height = 300;
    titem.width = 300;
  }

  //ChangeText(str, ranges);

  doc.activeLayer = doc.layers["Test"];
  ranges.apply(doc, doc.activeLayer, str, true);
};

RGBtoString = function(c) {
  if (c instanceof SolidColor) {
    c = c.rgb;
  }
  return "{r: " + c.red + ", g: " + c.green + ", b: " + c.blue + "}";
};

function main() {
  if (app.documents.length) {
    tsrDemo(app.activeDocument);
  } else {
    tsrDemo();
  }
};

main();

"TextRange.jsx";
// EOF
